Name:      ovs-agent
Version:   2.2
Release:   27
Summary:   Agent for Oracle Virtualization Suite.
License:   GPL
Group:     System Environment/Daemons
URL:       http://ovs.cn.oracle.com/
Source:    %{name}-%{version}.tar.bz2
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires:  python >= 2.4

%description
This is the Agent daemon for Oracle Virtualization Suite. It handles the
actual Virtual Machine operations in the backend.

%prep
%setup -q

%build
make build

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=${RPM_BUILD_ROOT} install
mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
install --mode=755 ovs-agent.init ${RPM_BUILD_ROOT}/etc/init.d/ovs-agent

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
    /sbin/chkconfig --add ovs-agent
    #configure agent with default value, mainly for regenerating admin password
    /etc/init.d/ovs-agent configure > /dev/null <<EOF




EOF
fi

# this script autogenerates a key for the agent for SSL configuration
# we use the hostname as extra data
if [ ! -f "/etc/ovs-agent/cert/key.pem" -o ! -f "/etc/ovs-agent/cert/certificate.pem" ]; then
    _hostname=$(uname -n)
    cd /etc/ovs-agent/cert
    openssl genrsa -out key.pem 1024
    openssl req -new -key key.pem -out request.pem << EOF
.
.
.
.
.
${_hostname}
.
.
.
EOF
    openssl x509 -req -days 1000 -in request.pem -signkey key.pem -out certificate.pem
fi

%preun
if [ "$1" = 0 ]; then # execute this only if we are NOT doing an upgrade
    /sbin/service ovs-agent stop --force >/dev/null 2>&1
    /sbin/chkconfig --del ovs-agent
fi

%files
%defattr(-,root,root)
/etc/init.d/ovs-agent
/opt/%{name}-%{version}

%changelog
* Tue Mar 11 2008 Junjie Wei<junjie.wei@oracle.com>, Dyno Fu<dyno.fu@oracle.com>
- bug#5406, pxe boot failed after set vif

* Fri Mar 07 2008 Junjie Wei<junjie.wei@oracle.com>
- bugfix#5379, set timeout for testing connection
- bugfix#5380, deal with vif=['']
- bugfix#5381, will not automatically change the type of vif but return fail
- bugfix#5384, remove mac info from default vm.cfg for pvm PXE booting

* Tue Feb 28 2008 Dyno Fu<dyno.fu@oracle.com>
- bug#5318, implement get_free_memory()
- bug#5305, implement get_vm_avail_disk_slot()

* Tue Feb 26 2008 Hongxi Ma<hongxi.ma@oracle.com>
- bug#5305, rewrote next_fe_de

* Tue Feb 26 2008 Dyno Fu<dyno.fu@oracle.com>
- bug#5294, select_tgt_host() should use real_vm_path to check vm type

* Mon Feb 18 2008 Dyno Fu<dyno.fu@oracle.com>
- add version check for site agent operations for backward compatibility

* Wed Jan 31 2008 Dyno Fu<dyno.fu@oracle.com>
- bug#4731, add xen_/optimize_os_profile()

* Wed Jan 30 2008 Dyno Fu<dyno.fu@oracle.com>
- bug#4731, os profile support for hvm installation
- add xen_remove_shared_disk() when cp_vm() in the same site

* Wed Jan 30 2008 Hongxi Ma<hongxi.ma@oracle.com>
- bug#5120, new xen_get_network_bridges

* Tue Jan 29 2008 Junjie Wei<junjie.wei@oracle.com>
- bug#5039, utl_wget() download file/dir to temp dir .wget

* Thu Jan 25 2008 Dyno Fu<dyno.fu@oracle.com>
- set_vm_vifs()/xen_set_vifs() remove is_append add mode parameter
- get_servers_vcaps() to support datacollector to detect server hvm support

* Thu Jan 24 2008 Dyno Fu<dyno.fu@oracle.com>
- filter server without hardware caps to run the vm. add xen_hypervisor_info()

* Thu Jan 22 2008 Dyno Fu<dyno.fu@oracle.com>
- bug#5058, add remove cdrom functionality to change_vm_cdrom()

* Tue Jan 22 2008 Hongxi Ma<hongxi.ma@oracle.com>
- bug#3990, monitor wget status periodically in asynchronous mode.

* Mon Jan 21 2008 Hongxi Ma<hongxi.ma@oracle.com>
- add asynchronous task scheduler

* Thu Jan 17 2008 Dyno Fu<dyno.fu@oracle.com>
- bug#4561, add device type support for set/get vif configuration
- bug#4996, remove dump file vm.save after restore

* Thu Jan 17 2008 Hongxi Ma<hongxi.ma@oracle.com>
- bug#4712, set_vm_preferred_servers/get_vm_preferred_servers to support
  setting preferred servers for a VM

* Thu Jan 10 2008 Junjie Wei<junjie.wei@oracle.com>
- Keep cdrom during installation to support windows installation
- restore_vm(), install_vm_*() enhancement, dedicated servers supported
- rename suspend_vm()/resume_vm() to pause_vm()/unpause_vm(), in line with xm
- get_agent_version() implemented
- config_boot_sequence() implemented, boot from hard disk, cdrom or network
- get_host_info() enhancement, xen_caps info included
- rename get_hw_caps() to get_xen_caps()
- add a file lock for vm.cfg to avoid write contention
- bugfix# 3994, 4888, 4679, 4242, 4706

* Thu Jan 10 2008 Dyno Fu<dyno.fu@oracle.com>
- support up to 4 disks for hvm
- bug#4010, password modification will not take effect immediately
- bug#4707, modify vm configuration at runtime

* Tue Nov 13 2007 Dyno Fu<dyno.fu@oracle.com>
- bug#4536, donnot remove original type setting, only workaround
  not a full solution

* Sat Nov 10 2007 Dyno Fu<dyno.fu@oracle.com>, Junjie Wei<junjie.wei@oracle.com>
- Hid ssl configuration, bug#4479
- Applied find_real_path() to cdrom/iso when install vm, bug#4483
- Implemented get_target_path() for cross-site cp storage balance,
- Change remove() behavior, bug#4484

* Fri Nov 09 2007 Kevin Lyons <kevin.x.lyons@oracle.com>
- Set ssl to enabled by default in agent.ini.default
- Added post install script to generate keys

* Sat Nov 03 2007 Dyno Fu<dyno.fu@oracle.com>
- impelent get_vm_vifs() & xen_get_vifs()

* Thu Nov 01 2007 Dyno Fu<dyno.fu@oracle.com>
- replace rpc.exp with rcp.py in favor of pexpect

* Thu Nov 01 2007 Dyno Fu<dyno.fu@oracle.com>
- replace parameter vif->vif_cfg in function install_vm*()

* Wed Oct 31 2007 Dyno Fu<dyno.fu@oracle.com>
- implement get_network_bridges(), set_vm_vifs(), clear_vm_vif_mac()

* Sat Oct 27 2007 Dyno Fu<dyno.fu@oracle.com>
- before migrate vm, check if the 2 server share same storage view.

* Sat Oct 27 2007 Junjie Wei<junjie.wei@oracle.com>
- set vm install, add params vnclisten, vncpasswd, tablet, keep-cdrom
  (patch virt-install required)

* Thu Oct 25 2007 Dyno Fu<dyno.fu@oracle.com>
- fix bug#3392, handle multiple partition

* Thu Oct 25 2007 Junjie Wei<junjie.wei@oracle.com>
- bugfix#4063,4013,4106,4107,4064
- implement check_shared_storage(), get_hw_caps(), get_host_arch() and is_bootable()

* Tue Oct 23 2007 Dyno Fu<dyno.fu@oracle.com>
- bugfix#3994,4008,4011,4022

* Tue Oct 16 2007 Junjie Wei<junjie.wei@oracle.com>
- various bugfix
- implement get_host_info

* Wed Oct 10 2007 Junjie Wei<junjie.wei@oracle.com>
- fix bug#3750, do not log the vnc password
- remove uuid when install vm from scratch

* Sun Oct 9 2007 Dyno Fu<dyno.fu@oracle.com>
- modify utils/config_agent.py to fix various bugs.

* Sun Oct 1 2007 Dyno Fu<dyno.fu@oracle.com>
- rename ovsagent to ovs-agent

* Sun Sep 30 2007 Dyno Fu<dyno.fu@oracle.com>, Junjie Wei<junjie.wei@oracle.com>
- rewrite change cdrom function
- various bugfix

* Sat Sep 29 2007 Junjie Wei<junjie.wei@oracle.com>
- implement add_vm_vif, del_vm_vif, get_vm_vnc_password, set_vm_vnc_password

* Sat Sep 29 2007 Dyno Fu<dyno.fu@oracle.com>
- rewrite get_vms_perf, loop throu servers not vms
- patch db_recovery, consider more cases

* Tue Sep 25 2007 Dyno Fu<dyno.fu@oracle.com>, Junjie Wei<junjie.wei@oracle.com>
- complete all the functions implemented previous
- rewrite agtctl, add client timeout to tackle cannot quit
  when child process running problem.

* Wed Sep 19 2007 Dyno Fu<dyno.fu@oracle.com>
- implement ssl support, but disable by default
- reorganize code layout

* Wed Sep 5 2007 Junjie Wei<junjie.wei@oracle.com>, Dyno Fu<dyno.fu@oracle.com>
- implement vm installation from scratch (hvm & para)
- check free disk space before cp vm, create vm disk, vm installation etc
- update exported function inline document

* Tue Aug 21 2007 Dyno Fu <dyno.fu@oracle.com>
- rewrite OVSSiteAgent process logic
- implement get vnc connection string
- fix bug#3249, bug#3233

* Tue Jul 24 2007 Dyno Fu <dyno.fu@oracle.com>
- reenable configure network, pass parameter throu kernel cmdline

* Sat Jul 21 2007 Dyno Fu <dyno.fu@oracle.com>
- start vm remove invalid disk path
- add default config file, try not to overwrite previous config
- various bugfix

* Thu Jul 19 2007 Dyno Fu <dyno.fu@oracle.com>
- better exception/error logging "err msg=> %s: %s" % (e.__class__.__name__, e)
- run_cmd handle cmd more consistently
- reorg site db
- add READLOCK status & reference counter 'readlock' to allow concurrent cp
- add license comment
- add security check for any write operation upon vm
- add register default site when agent start
- broadcast (mac, ip) & get mac with xm list --long (in fact alot of other information)
- implement /etc/init.d/ovsagent configure

* Thu May 25 2007 Dyno Fu <dyno.fu@oracle.com>
- modify post configuration

* Thu Jan 11 2007 Zhigang Wang <zhigang.x.wang@oracle.com>
- initial ovsagent spec file
